'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "!WQYQPOOOkQPO'#CeOOQO'#Cj'#CjOOQO'#Cf'#CfQYQPOOOOQO,59P,59POrQPO,59POOQO-E6d-E6dOOQO1G.k1G.k",
  stateData: "|~O]OSPOS~ORQOSQOTQOUQOWPO~OVTO~PYOVWO~PYOST~",
  goto: "v_PPPPPPPPP`fPPPpXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program Identifier String Name Number ) ( Application",
  maxTerm: 14,
  nodeProps: [
    ["openedBy", 7,"("],
    ["closedBy", 8,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%X~R_XY!QYZ!Q]^!Qpq!Qst!cxy!zyz#P}!O#U!O!P#g!Q![#[!c!v#u!v!w#}!w!}#u#R#S$q#T#o$q~!VS]~XY!QYZ!Q]^!Qpq!Q~!hSP~OY!cZ;'S!c;'S;=`!t<%lO!c~!wP;=`<%l!c~#POW~~#UOV~~#XP!Q![#[~#aQU~!O!P#g!Q![#[~#jP!Q![#m~#rPU~!Q![#m~#zPT~#T#o#u~$SQT~!Q![$Y#T#o#u~$]Q!O!P$c!Q![$Y~$fP!Q![$i~$nPS~!Q![$i~$vRR~!Q![%P#R#S$q#T#o$q~%UPR~!Q![%P",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 41
});

/// A collection of JavaScript-related
/// [snippets](#autocomplete.snippet).
const snippets = [
    // compare
    autocomplete.snippetCompletion("(${value1} if ${condition} else ${value2})", {
        label: "if ... else",
        type: "keyword"
    }),
    // math
    autocomplete.snippetCompletion("dif(${tag})", {
        label: "dif",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("max(${tag})", {
        label: "max",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("min(${tag})", {
        label: "min",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("avg(${tag})", {
        label: "avg",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("abs(${param})", {
        label: "abs",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("exp(${param})", {
        label: "exp",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("log(${param})", {
        label: "log",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("log10(${param})", {
        label: "log10",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("sqrt(${param})", {
        label: "sqrt",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("pow(${param}, ${degree})", {
        label: "pow",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("hypot(${param}, ${param2})", {
        label: "hypot",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("round(${param})", {
        label: "round",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("floor(${param})", {
        label: "floor",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("ceil(${param})", {
        label: "ceil",
        type: "keyword"
    }),
    // constants 
    autocomplete.snippetCompletion("Pi", {
        label: "Pi",
        type: "constant"
    }),
    autocomplete.snippetCompletion("E", {
        label: "E",
        type: "constant"
    }),
    // trigonometric
    autocomplete.snippetCompletion("sin(${param})", {
        label: "sin",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("asin(${param})", {
        label: "asin",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("sinh(${param})", {
        label: "sinh",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("cos(${param})", {
        label: "cos",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("acos(${param})", {
        label: "acos",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("cosh(${param})", {
        label: "cosh",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("tan(${param})", {
        label: "tan",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("atan(${param})", {
        label: "atan",
        type: "keyword"
    }),
    autocomplete.snippetCompletion("tanh(${param})", {
        label: "tanh",
        type: "keyword"
    }),
];

const mathLanguage = language.LRLanguage.define({
    name: 'math',
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlight.styleTags({
                Identifier: highlight.tags.variableName,
                Name: highlight.tags.name,
                String: highlight.tags.string,
                Number: highlight.tags.number,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
function math() {
    return new language.LanguageSupport(mathLanguage, [
        mathLanguage.data.of({
            autocomplete: autocomplete.completeFromList(snippets)
        })
    ]);
}

exports.math = math;
exports.mathLanguage = mathLanguage;
